#! /usr/bin/env python

import nest
import unittest


class Test(unittest.TestCase):

    def test_load_neurons(self):
        # test neuron creation + value setting
        neuron_models = []
        neuron_params = []

        neuron_models += ['eif_psc_exp']
        neuron_params += [None]

        neuron_models += ['aeif_psc_delta_unsafe']
        neuron_params += [None]

        neuron_models += ['aeif_psc_exp_unsafe']
        neuron_params += [None]

        neuron_models += ['aeif_psc_alpha_unsafe']
        neuron_params += [None]

        neuron_models += ['aeif_cond_exp_unsafe']
        neuron_params += [None]

        neuron_models += ['aeif_cond_alpha_unsafe']
        neuron_params += [None]

        for m, p in zip(neuron_models, neuron_params):
            nest.ResetKernel()

            try:
                n = nest.Create(m, 10)
                if p is not None:
                    nest.SetStatus(n, p)

            except nest.NESTError as e:
                self.fail(e)

if __name__ == '__main__':
    nest.Install('unsafemodule')

    unittest.main()
